SystemOrganization addCategory: #'Pier-Wysiwyg'!

WAComponent subclass: #PRWysiwygEditor
	instanceVariableNames: 'pierWikiText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Wysiwyg'!

!PRWysiwygEditor methodsFor: 'accessing' stamp: 'NickAger 7/5/2011 13:38'!
pierWikiText
	^ pierWikiText ifNil: [ '' ]! !

!PRWysiwygEditor methodsFor: 'accessing' stamp: 'NickAger 7/5/2011 13:36'!
pierWikiText: anObject
	pierWikiText := anObject! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/5/2011 13:44'!
renderContentOn: html
html form: [
	html table
		cellpadding: 0;
		cellspacing: 0;
		with: [
			html tableRow: [	
					html tableData: [
	html html: '<textarea name="msgpost" id="msgpost" cols="50" rows="10">
    <strong>Your</strong> HTML <em>code</em> goes here.<br>
    This text will be pre-loaded in the editor when it is rendered.
</textarea>'.

	html script: 'var myEditor = new YAHOO.widget.Editor("msgpost", {
    height: "300px",
    width: "522px",
    dompath: true, //Turns on the bar at the bottom
    animate: true //Animates the opening, closing and moving of Editor windows
});
myEditor.render();
YAHOO.util.Event.on("somebutton", "click", function() {
    //Put the HTML back into the text area
    myEditor.saveHTML();
 
    //The var html will now have the contents of the textarea
    var html = myEditor.get("element").value;
    alert(html);});
' ].
	html tableData: [
		html button
			bePush;
			onClick: ((html jQuery id: #htmlToPierConversion) value: (JSStream on: 'parseHtmlToPierWikiSyntax(myEditor._getDoc().body)'));
			onClick: ((html jQuery ajax script: [:s | s << ((s jQuery id: #pierBackToHtml) html: [: r | self renderPierToHtmlOn: r ]) ]) serialize: (html jQuery id: #htmlToPierConversion));
			with: 'convert >>' ].

	html tableData: [
		html heading level3; with: 'Pier Syntax'.
		html textArea 
			columns: 60;
			rows: 20;
			id: #htmlToPierConversion;
			on: #pierWikiText of: self.

		html heading level3; with: 'Pier converting back into html'.
			html div id: #pierBackToHtml ] ] ] ]! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/5/2011 13:37'!
renderPierToHtmlOn: html
	"renders wiki text into html"
	| parsedStructure renderer |
		
	parsedStructure := PRDocumentParser parseStream: self pierWikiText readStream.
	renderer := PRViewRenderer new.
	renderer withinContentDo: [
		renderer start: parsedStructure in: self on: html ]! !

!PRWysiwygEditor methodsFor: 'updating' stamp: 'NickAger 7/5/2011 13:26'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	
	"See YUI editor documentation: 
		* http://developer.yahoo.com/yui/editor/
		* http://yuiblog.com/assets/pdf/cheatsheets/editor.pdf"
	
	anHtmlRoot stylesheet url: 'http://yui.yahooapis.com/2.9.0/build/assets/skins/sam/skin.css'.
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/yahoo-dom-event/yahoo-dom-event.js'.
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/element/element-min.js'.

	"Needed for Menus, Buttons and Overlays used in the Toolbar"
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/container/container_core-min.js'.
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/menu/menu-min.js'.
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/button/button-min.js'.
	"Source file for Rich Text Editor"
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/editor/editor-min.js'.	
	
	anHtmlRoot bodyAttributes addClass: 'yui-skin-sam'.
	
	anHtmlRoot javascript url: PRWysiwygFileLibrary / #parseHtmlToPierWikiSyntaxJs
	
! !

WAFileLibrary subclass: #PRWysiwygFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Wysiwyg'!

!PRWysiwygFileLibrary methodsFor: 'uploaded' stamp: 'NickAger 7/5/2011 13:47'!
parseHtmlToPierWikiSyntaxJs
	^ 'var parseHtmlToPierWikiSyntax = function (startNode) {
	var wikiOutput = [];
	var newLine = "\n"
	
	var surroundingMarkup = function(markup) {
		return function(node) {
			wikiOutput.push(markup);
			walkTheDOM (node.firstChild);
			wikiOutput.push(markup)
		}
	}

	var startLineMarkup = function(markup, addEndingNewLine) {
		return function(node) {
			wikiOutput.push(newLine);
			if (markup.length) {
				wikiOutput.push(markup);
			}
			walkTheDOM (node.firstChild);
			
			if (addEndingNewLine) {
				wikiOutput.push(newLine);
			}
		}
	}
	
	var listWalk = function () {
		return function (node) {
			var startLength = wikiOutput.length;
			walkTheDOM (node.firstChild);
			var endLength = wikiOutput.length;
			
			console.log (wikiOutput);
			// remove consecutive new lines. 
			var previousNewLineIndex = -1;
			for (var i = startLength - 1; i < endLength; ++i) {
				if (wikiOutput [i] == newLine) {
					// we have consecutive new lines.
					if (previousNewLineIndex == i - 1) {
						delete wikiOutput [i];
					}
				previousNewLineIndex = i;		
				}
			}
			
			// ensure we finish with a new line
			if (wikiOutput [wikiOutput.length - 1] && wikiOutput [wikiOutput.length - 1] !!= newLine) {
				wikiOutput.push(newLine);
			}
			console.log (wikiOutput);
		}
	}
	
	var listElement = function () {
		return function (node) {
			var parentNodeName = nodeName = node.parentNode.nodeName.toLowerCase();
			if (parentNodeName == ''ul'') {
				startLineMarkup(''-'', false)(node)
			}
			if (parentNodeName == ''ol'') {
				startLineMarkup(''#'', false)(node)
			}
		}
	}
	
	var tableMarkup = function () {
		return function () {}
	}
	
	var anchor = function(node) {
		return function(node) {
			if(node.getAttribute("href")) {
				var baseUrl = window.location.host;
				var anchorUrl = node.getAttribute("href");
				var url;

				if(anchorUrl.indexOf(baseURl) == 0) {
					url = anchorUrl.substr(0, baseUrl.length);
				} else {
					url = anchorUrl;
				}

				wikiOutput.push("*");
				walkTheDOM(node.firstChild);
				wikiOutput.push(">");
				wikiOutput.push(node.getAttribute("href"));
				wikiOutput.push("*");
			}
		}
	}
	
	var handleText = function(node) {
		var text = node.nodeValue;

		// if the string starts with a newLine strip it.
		if (text.length && text [0] == newLine) {
			text = text.substr(1, text.length - 1); 
		}		
		
		// if the string ends with a newLine strip it.
		if (text.length && text [text.length - 1] == newLine) {
			text = text.substr(0, text.length - 2); 
		}
		
		if (text.trim().length !!== 0) {
			wikiOutput.push(text);
		}
	}

	var elementToWikiMarkupMappingTable = {
		''b'': surroundingMarkup(''\"\"''),
		''strong'': surroundingMarkup(''\"\"''),
		''i'': surroundingMarkup("\''\''"),
		''em'': surroundingMarkup("\''\''"),
		''hr'': surroundingMarkup("__"),
		''code'': surroundingMarkup("=="),
		''sub'': surroundingMarkup("@@"),
		''sup'': surroundingMarkup("^^"),
		''a'': anchor(),
		''h1'': startLineMarkup (''!!'', true),
		''h2'': startLineMarkup(''!!!!'', true), 
		''h3'': startLineMarkup(''!!!!!!'', true),
		''h4'': startLineMarkup(''!!!!!!!!'', true), 
		''h5'': startLineMarkup(''!!!!!!!!!!'', true), 
		''h6'': startLineMarkup(''!!!!!!!!!!!!'', true),
		''hr'': startLineMarkup(''_'', true),
		"br": startLineMarkup('''', true),
		"p": startLineMarkup('''', true),
		"ul": listWalk(),
		"ol": listWalk(),	
		''li'': listElement(),	
		''dl'': startLineMarkup('';'', true),
		''dd'': startLineMarkup('':'', true),
		''pre'': startLineMarkup(''='', true),
		''table'': tableMarkup()
	}

    var nodeTypes = {
        ELEMENT_NODE: 1,
        ATTRIBUTE_NODE: 2,
        TEXT_NODE: 3,
        CDATA_SECTION_NODE: 4,
        ENTITY_REFERENCE_NODE: 5,
        ENTITY_NODE: 6,
        PROCESSING_INSTRUCTION_NODE: 7,
        COMMENT_NODE: 8,
        DOCUMENT_NODE: 9,
        DOCUMENT_TYPE_NODE: 10,
        DOCUMENT_FRAGMENT_NODE: 11,
        NOTATION_NODE: 12
    }
	
	// the recursive DOM walker
    var walkTheDOM = function (node) {
		if (node === null)
			return ;
			
		switch (node.nodeType) {
            case nodeTypes.ELEMENT_NODE:
			var nodeName = node.nodeName.toLowerCase();
			if (elementToWikiMarkupMappingTable.hasOwnProperty (nodeName)) {
				elementToWikiMarkupMappingTable [nodeName](node);
			}
			break;
                
            case nodeTypes.TEXT_NODE:
			handleText(node);
			break; 
                
            case nodeTypes.ATTRIBUTE_NODE:
            case nodeTypes.CDATA_SECTION_NODE:
            case nodeTypes.ENTITY_REFERENCE_NODE:
            case nodeTypes.ENTITY_NODE:
            case nodeTypes.PROCESSING_INSTRUCTION_NODE:
            case nodeTypes.COMMENT_NODE:
            case nodeTypes.DOCUMENT_NODE:
            case nodeTypes.DOCUMENT_TYPE_NODE:
            case nodeTypes.DOCUMENT_FRAGMENT_NODE:
            case nodeTypes.NOTATION_NODE:
                break;
			}

		walkTheDOM (node.nextSibling);
    }
	walkTheDOM (startNode.firstChild);
	return wikiOutput.join('''');
}' withInternetLineEndings! !
